package chapter3;

import org.springframework.test.AbstractSingleSpringContextTests;

import chapter2.second.Instrumentalist;
import chapter3.first.Vocalist;

public class BeanAbstractingTest extends AbstractSingleSpringContextTests {

	@Override
	protected String[] getConfigLocations() {
		return new String[] { "file:src/chapter3/first/abstractingBeanContext.xml" };
	}

	private Instrumentalist kenny;

	private Instrumentalist david;

	private Instrumentalist frank;

	private Vocalist taylor;

	private Instrumentalist steave;

	@Override
	protected void onSetUp() throws Exception {
		kenny = (Instrumentalist) applicationContext.getBean("kenny");
		david = (Instrumentalist) applicationContext.getBean("david");
		frank = (Instrumentalist) applicationContext.getBean("frank");
		taylor = (Vocalist) applicationContext.getBean("taylor");
		steave = (Instrumentalist) applicationContext.getBean("steave");
	}

	public void testDi() throws Exception {
		assertNotNull(kenny);
		assertNotNull(david);
		assertNotNull(frank);
		assertNotNull(taylor);
		assertNotNull(steave);
	}

	public void testProperties() throws Exception {
		String song = "Jingle Bells";
		assertEquals(song, kenny.getSong());
		assertEquals(song, david.getSong());
	}

	public void testSong() throws Exception {
		String song = "Somewhere Over the Rainbow";
		assertEquals(song, taylor.getSong());
		assertEquals(song, steave.getSong());
	}
}
